#include <ESP8266WiFi.h>

void connectWifi(String ssid_temp, String password_temp){
  // Connect to WiFi network
  // call with specific credentials : connectWifi("ssid","password")
  // call without specific credentials : connectWifi("","")
  
  WiFi.mode(WIFI_STA);     // Station only, ESP als AP may interfere with other AP's 

  while (WiFi.status() != WL_CONNECTED) {
    if ( (ssid_temp != "") && (password_temp != "") ) WiFi.begin(ssid_temp.c_str(), password_temp.c_str());
    else WiFi.begin();
    
    // wait for connection, or timeout
    Serial.print("\nConnecting ");
    for (int i=1;i<=20;i++){
     if (WiFi.status() == WL_CONNECTED) break;
     delay(500);
     Serial.print(".");
    }
    if (WiFi.status() != WL_CONNECTED) {
      // cached credentials or specified did not result in a connect, ask the user for credentials
      Serial.setTimeout(10000);
      Serial.println("\nEnter SSID and Password, or wait to connect with previous succesfull credentials");
      // make sure that NO \r or \n remain in the entered String !!!!!
      Serial.print("SSID:"); ssid_temp=Serial.readStringUntil('\n'); ssid_temp.replace("\n",""); ssid_temp.replace("\r",""); Serial.println(ssid_temp);
      Serial.print("Password:"); password_temp=Serial.readStringUntil('\n');  password_temp.replace("\n","");  password_temp.replace("\r",""); // Serial.println(password_temp);
      Serial.print("Connecting to:"); Serial.print(ssid_temp);
      // now retry the connectconnect   
    } // end if
  } // end while
      
  // success
  Serial.println();
  Serial.print("Connected to SSID : ");
  // print the SSID of the network you're attached to:
  Serial.print(WiFi.SSID());
  
  // print your WiFi shield's IP address:
  IPAddress ip = WiFi.localIP();
  Serial.print(", IP Address : ");
  Serial.println(ip);
}
